/*-------------------------------------------------------------------------*
    MODEM.H

    class definition for telephone modem module

    Stephen R. Schmitt
    962 Depot Road
    Boxborough, MA 01719
 *-------------------------------------------------------------------------*/

#ifndef MODEM_H
#define MODEM_H

class modem
{
public:
    int  validate_port( char * );
    int  set_up_comm();
    int  place_call( char *, char );
    int  send_string( char * );
    int  get_line( char *, int );
    void hang_up();
    int  status_code();

private:
    char in_buffer[80];                         // input comm buffer  
    int  port;                                  // int 14h port number  
    int  hw_port;                               // hardware port address 
    int  mcr_port;                              // modem control reg port 
    int  mcr_val;                               // mcr value w/o DTR & RTS 
    int  status;
};

#endif